import { OnDestroy, OnInit } from '@angular/core';
import { DomSanitizer, SafeHtml, SafeUrl } from '@angular/platform-browser';
import { LxlibLocaleService, LocaleData } from '@lxlib/theme';
export declare type ExceptionType = 403 | 404 | 500;
export declare class ExceptionComponent implements OnInit, OnDestroy {
    private i18n;
    private dom;
    private i18n$;
    private conTpl;
    _type: ExceptionType;
    locale: LocaleData;
    hasCon: boolean;
    _img: SafeUrl;
    _title: SafeHtml;
    _desc: SafeHtml;
    set type(value: ExceptionType);
    private fixImg;
    set img(value: string);
    set title(value: string);
    set desc(value: string);
    checkContent(): void;
    constructor(i18n: LxlibLocaleService, dom: DomSanitizer);
    ngOnInit(): void;
    ngOnDestroy(): void;
}
