import { AfterViewInit, ChangeDetectorRef, OnChanges, OnDestroy, OnInit, Renderer2, TemplateRef } from '@angular/core';
import { Router } from '@angular/router';
import { ReuseTabService } from '@lxlib/seed/reuse-tab';
import { LxlibI18NService, MenuService, SettingsService, TitleService } from '@lxlib/theme';
import { PageHeaderConfig } from './page-header.config';
interface PageHeaderPath {
    title?: string;
    link?: string[];
}
export declare class PageHeaderComponent implements OnInit, OnChanges, AfterViewInit, OnDestroy {
    private renderer;
    private router;
    private menuSrv;
    private i18nSrv;
    private titleSrv;
    private reuseSrv;
    private cdr;
    private inited;
    private unsubscribe$;
    private conTpl;
    private affix;
    private _menus;
    private get menus();
    _titleVal: string;
    paths: PageHeaderPath[];
    _title: string | null;
    _titleTpl: TemplateRef<void>;
    set title(value: string | TemplateRef<void>);
    loading: boolean;
    wide: boolean;
    home: string;
    homeLink: string;
    homeI18n: string;
    autoBreadcrumb: boolean;
    autoTitle: boolean;
    syncTitle: boolean;
    fixed: boolean;
    fixedOffsetTop: number;
    breadcrumb: TemplateRef<void>;
    recursiveBreadcrumb: boolean;
    logo: TemplateRef<void>;
    action: TemplateRef<void>;
    content: TemplateRef<void>;
    extra: TemplateRef<void>;
    tab: TemplateRef<void>;
    constructor(cog: PageHeaderConfig, settings: SettingsService, renderer: Renderer2, router: Router, menuSrv: MenuService, i18nSrv: LxlibI18NService, titleSrv: TitleService, reuseSrv: ReuseTabService, cdr: ChangeDetectorRef);
    refresh(): void;
    private genBreadcrumb;
    private setTitle;
    checkContent(): void;
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnChanges(): void;
    ngOnDestroy(): void;
}
export {};
